var gts = require('gulp-typescript');
var ts = require('typescript');

function compileSource(tsConfig, options) {
  options = options || {};
  options.typescript = options.typescript || ts;
  options.jsx = options.jsx || "react";
  console.log("Compile - Typescript version " + options.typescript.version + " :: " + tsConfig);
  var tsProject = gts.createProject(tsConfig, options);
  return tsProject.src().pipe(gts(tsProject));
}

function compile(name, gulp, tsConfig, outputFolder, options) {
  return compileSource(tsConfig, options)[name].pipe(gulp.dest(outputFolder));
}

var tsCompiler = {
  ts: function(gulp, tsConfig, outputFolder, options) {
    return compile("js", gulp, tsConfig, outputFolder, options);
  },

  dts: function(gulp, tsConfig, outputFolder, options) {
    return compile("dts", gulp, tsConfig, outputFolder, options);
  }
}
module.exports = tsCompiler;
